import processing.opengl.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.*;

GL  gl;
GLU glu;
float aspect, camZ, xx, yy;

void setup(){
  size(400,400,OPENGL);
  hint(DISABLE_OPENGL_2X_SMOOTH);     // get rid of the irritating aliasing
  hint(DISABLE_OPENGL_ERROR_REPORT);  // speed performance slightly
  aspect=(float)width/(float)height;
  camZ=((height/2.0) / tan(PI*60.0/360.0));
  glu = new GLU();
  gl = ((PGraphicsOpenGL)g).gl;
}

void draw(){
  gl.glMatrixMode(GL.GL_PROJECTION);
  gl.glLoadIdentity();
  glu.gluPerspective(180/3.0, aspect, camZ/10.0, camZ*10.0);
  glu.gluLookAt(0, 0, camZ, 0, 0, 0, 0, 1, 0);
  gl.glColor4f(0,0,0,.02);
  gl.glBegin(GL.GL_TRIANGLE_STRIP);
  gl.glVertex3f(-width/2,-height/2,0);
  gl.glVertex3f(width/2,-height/2,0);
  gl.glVertex3f(-width/2,height/2,0);
  gl.glVertex3f(width/2,height/2,0);
  gl.glEnd();
  xx=mouseX-width/2;
  yy=mouseY-width/2;
  gl.glColor3f(1,1,1);
  gl.glBegin(GL.GL_TRIANGLE_STRIP);
  gl.glVertex3f(xx-20,yy-20,0);
  gl.glVertex3f(xx+20,yy-20,0);
  gl.glVertex3f(xx-20,yy+20,0);
  gl.glVertex3f(xx+20,yy+20,0);
  gl.glEnd();
}


